#pragma once

#include <tchar.h>
#include <Windows.h>
#include "StandardMidiFormat.hpp"
#include "Synthesizer.hpp"

class KeyBind;

/**
 * VZTCU[
 *
 * tL[{[h͂Ƃďo͂
 */
class KeyboardSynthesizer : public Synthesizer
{
public:

	/**
	 * RXgN^
	 */
	KeyboardSynthesizer(const KeyBind* keyBind);

	virtual ~KeyboardSynthesizer();

	virtual bool open();

	virtual void close();

	virtual void press(BYTE noteNumber);

	virtual void release(BYTE noteNumber);

	virtual void reset();

private:

	/**
	 * L[oCh
	 */
	const KeyBind* keyBind_;

	/**
	 * XLR[he[u (CfbNX͉zL[R[h)
	 *
	 * 擾(l)0xffff
	 * 擾悤Ƃǎ擾s̏ꍇ0x0000
	 */
	WORD scanCodes_[256];

	/**
	 * L[{[hpf[^
	 */
	INPUT keyboard_;

	/**
	 * rp̃NeBJZNV
	 */
	CRITICAL_SECTION criticalSection_;

	/**
	 * L[{[h̃L[_E
	 *
	 * @param virtualKey zL[R[h
	 */
	void keyDown(BYTE virtualKey);

	/**
	 * L[{[h̃L[Abv
	 *
	 * @param virtualKey zL[R[h
	 */
	void keyUp(BYTE virtualKey);

	/**
	 * zL[R[hXLR[h擾
	 *
	 * @param virtualKey zL[R[h
	 *
	 * @return XLR[h
	 */
	WORD getScanCode(BYTE virutalKey);
};
